      subroutine orbite(pls,pdist_star,pdecli)
      implicit none

!==================================================================
!     
!     Purpose
!     -------
!     Distance from star and declination as a function of the stellar
!     longitude Ls
!     
!     Inputs
!     ------
!     pls          Ls
!
!     Outputs
!     -------
!     pdist_star    Distance Star-Planet in UA
!     pdecli        declinaison ( in radians )
!
!=======================================================================

c   Declarations:
c   -------------

!-----------------------------------------------------------------------
! INCLUDE planet.h

      COMMON/planet/apoastr,periastr,year_day,peri_day,                 &
     &       obliquit,nres,                                             &
     &       z0,lmixmin,emin_turb,coefvis,coefir,                       &
     &       timeperi,e_elips,p_elips

      real apoastr,periastr,year_day,peri_day,                          &
     &     obliquit,nres,                                               &
     &     z0,lmixmin,emin_turb,coefvis,coefir,                         &
     &       timeperi,e_elips,p_elips
      

!-----------------------------------------------------------------------
!-----------------------------------------------------------------------
! INCLUDE "comcstfi.h"

      common/comcstfi/pi,rad,g,r,cpp,rcp,dtphys,daysec,mugaz,omeg
      common/comcstfi/avocado!,molrad,visc
      
      real pi,rad,g,r,cpp,rcp,dtphys,daysec,mugaz,omeg
      real avocado!,molrad,visc


c arguments:
c ----------

      REAL pday,pdist_star,pdecli,pls,i

c-----------------------------------------------------------------------

c Star-Planet Distance

      pdist_star = p_elips/(1.+e_elips*cos(pls+timeperi))

c Stellar declination

c ********************* version before 01/01/2000 *******

      pdecli = asin (sin(pls)*sin(obliquit*pi/180.))

c ********************* version after 01/01/2000 *******
c     i=obliquit*pi/180.
c     pdecli=asin(sin(pls)*sin(i)/sqrt(sin(pls)**2+
c    & cos(pls)**2*cos(i)**2))
c ******************************************************

      RETURN
      END
